<ns-action-bar-container></ns-action-bar-container>
<account-frame
  *ngIf="!hasFinished"
  title="Change Account Password"
  submitText="Change Password"
  (onSubmit)="onSubmit()"
  [nonFieldErrors]="nonFieldErrors"
>
  <label
    class="m-b-10 text-label"
    textWrap="true"
    text="For your security, Passit replaces your backup code when you change your password. Make sure you save your new code."
  ></label>

  <label class="m-b-40 text-label" (tap)="changeBackupCode()" textWrap="true">
    <FormattedString>
      <span text="Only want a new backup code? "></span>
      <span class="text-link" text="Change backup code &#8250;"></span>
    </FormattedString>
  </label>
  <app-text-field
    #password
    autocorrect="false"
    autocapitalizationType="none"
    type="password"
    label="Current Password"
    returnKeyType="next"
    [isFormSubmitted]="form.isSubmitted"
    [ngrxFormControl]="form.controls.oldPassword"
  ></app-text-field>

  <app-text-field
    #passwordInput
    autocorrect="false"
    autocapitalizationType="none"
    type="password"
    label="New Password"
    returnKeyType="next"
    [isFormSubmitted]="form.isSubmitted"
    [ngrxFormControl]="form.controls.newPassword"
  ></app-text-field>

  <StackLayout
    class="p-b-10"
    *ngIf="form.isInvalid && form.isSubmitted && form.errors._newPassword"
  >
    <label
      *ngIf="form.errors._newPassword.required"
      class="text-label text-label--error m-b-10"
      textWrap="true"
      text="You must have a password!"
    ></label>
    <label
      *ngIf="form.errors._newPassword.minLength"
      class="text-label text-label--error m-b-10"
      textWrap="true"
      text="Password must be at least {{
        form.errors._newPassword.minLength.minLength
      }} characters long!"
    ></label>
    <label
      *ngIf="form.errors._newPassword.hasUniqueChars"
      class="text-label text-label--error m-b-10"
      textWrap="true"
      text="Password must have more than 5 unique characters."
    ></label>
    <label
      *ngIf="form.errors._newPassword.notNumeric"
      class="text-label text-label--error m-b-10"
      textWrap="true"
      text="Password must not be only numbers."
    ></label>
    <label
      *ngIf="form.errors._password.notEqualTo"
      class="text-label text-label--error m-b-10"
      text="Password must not be email address."
      textWrap="true"
    ></label>
    <label
      *ngIf="form.errors._newPassword.notEqualTo"
      class="text-label text-label--error m-b-10"
      textWrap="true"
      text="New password is the same as the old password."
    ></label>
  </StackLayout>
  <label
    *ngIf="form.controls.newPassword.isInvalid"
    class="text-label m-b-10"
    textWrap="true"
  >
    <FormattedString>
      <span text="Make a "></span>
      <span text="long" class="font-weight-bold"></span>
      <span text=" password. We require at least 10 characters."></span>
    </FormattedString>
  </label>
  <label
    *ngIf="form.controls.newPassword.isInvalid"
    class="text-label m-b-20"
    textWrap="true"
  >
    <FormattedString>
      <span text="A good password is also "></span>
      <span text="unique, memorable," class="font-weight-bold"></span>
      <span text=" and "></span>
      <span text="impersonal." class="font-weight-bold"></span>
    </FormattedString>
  </label>

  <label
    *ngIf="
      !form.errors._newPassword &&
      !form.value.newPasswordConfirm &&
      form.value.showConfirm
    "
    class="text-label m-b-20"
    textWrap="true"
    text="Good! Now retype your password below to confirm what you entered."
  ></label>
  <label
    *ngIf="!form.errors._newPassword && !form.value.showConfirm"
    class="text-label"
    textWrap="true"
    text="Remember, Passit cannot reset a forgotten password. Consider writing it down and storing it somewhere safe."
  ></label>

  <app-text-field
    #password
    autocorrect="false"
    autocapitalizationType="none"
    type="password"
    label="Confirm New Password"
    returnKeyType="done"
    [isFormSubmitted]="form.isSubmitted"
    [ngrxFormControl]="form.controls.newPasswordConfirm"
    (returnPress)="onSubmit()"
  ></app-text-field>

  <StackLayout
    class="p-b-10"
    *ngIf="
      form.isInvalid && form.isSubmitted && form.errors._newPasswordConfirm
    "
  >
    <label
      *ngIf="
        form.errors._newPasswordConfirm.equalTo &&
        form.controls.showConfirm.value
      "
      class="text-label text-label--error m-b-10"
      textWrap="true"
      text="Passwords don't match."
    ></label>
  </StackLayout>
  <progress-indicator
    [inProgress]="hasStarted"
    inProgressText="Passit is updating your password."
    [completed]="hasFinished"
    completedText="Your password has been successfully updated."
  ></progress-indicator>
</account-frame>
<app-download-backup-code *ngIf="hasFinished" [code]="backupCode">
</app-download-backup-code>
